// DemoFrameListener.h

#ifndef DEMO_FRAME_LISTENER_H
#define DEMO_FRAME_LISTENER_H

#include "ExampleFrameListener.h"

using namespace Ogre;

class DemoFrameListener : public ExampleFrameListener
{
protected:
	SceneManager* mSceneMgr;

public:
	DemoFrameListener(SceneManager* sceneMgr, RenderWindow* window, Camera* camera) : ExampleFrameListener(window, camera)
	{
		mSceneMgr = sceneMgr;
	}

	virtual ~DemoFrameListener()
	{
	}

	virtual bool frameStarted(const FrameEvent& evt)
	{
		if(!ExampleFrameListener::frameStarted(evt))
			return false;

		// On fait avancer l'avion
		mSceneMgr->getRootSceneNode()->getChild("CameraNode")->translate(
			Vector3(0.0, 0.0, -100.0*evt.timeSinceLastFrame), Node::TS_LOCAL);

		return true;
	}

/*	virtual bool processUnbufferedMouseInput(const FrameEvent& evt)
	{
		return true;
	}
*/
	virtual bool processUnbufferedKeyInput(const FrameEvent& evt)
	{
		using namespace OIS;

		static bool fog_enabled = true;

		if(mKeyboard->isKeyDown(KC_X))
		{
			if(!fog_enabled)
			{
				mSceneMgr->setFog(
					FOG_LINEAR,		// Type de fog
					ColourValue(0.9, 0.9, 0.9),	// Couleur du fog
					0.0,	// expDensity : utilisé pour le fog exponentiel
					10,		// linearStart
					50);	// linearEnd
				printf("DEBUG : fog active\n");
			}
			else
			{
				mSceneMgr->setFog(FOG_NONE);
				printf("DEBUG : fog desactive\n");
			}
			fog_enabled = !fog_enabled;
		}


		// Right / Left
		if(mKeyboard->isKeyDown(KC_RIGHT))
			mCamera->getParentSceneNode()->roll(-mRotScale);

		if(mKeyboard->isKeyDown(KC_LEFT))
			mCamera->getParentSceneNode()->roll(mRotScale);

		// Up / Down
		if(mKeyboard->isKeyDown(KC_UP))
			mCamera->getParentSceneNode()->pitch(-mRotScale);

		if(mKeyboard->isKeyDown(KC_DOWN))
			mCamera->getParentSceneNode()->pitch(mRotScale);

		// DEBUG
		if(mKeyboard->isKeyDown(KC_PGUP))
			mTranslateVector.z = -mMoveScale;

		if(mKeyboard->isKeyDown(KC_PGDOWN))
			mTranslateVector.z = mMoveScale;

		// Echap : on quitte
		if(mKeyboard->isKeyDown(KC_ESCAPE))
			return false;

		return true;
	}

	virtual void moveCamera()
	{
		mCamera->getParentSceneNode()->yaw(mRotX);
		mCamera->getParentSceneNode()->pitch(mRotY);
		mCamera->getParentSceneNode()->translate(mTranslateVector, Node::TS_LOCAL);
	}
};

#endif // DEMO_FRAME_LISTENER_H
